## gloo 0.0~git20200918.3dc0328

=== CMakeLists.txt ===
# GLOO_SRCS is the list of source files that we need to build libgloo.
set(GLOO_SRCS)

# GLOO_HDRS is the list of header files that we need to install.
set(GLOO_HDRS)

# Compiled sources in root directory
list(APPEND GLOO_SRCS
  "${CMAKE_CURRENT_SOURCE_DIR}/algorithm.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/allgather.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/allgatherv.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/allreduce.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/allreduce_local.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/alltoall.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/alltoallv.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/barrier.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/broadcast.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/context.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/gather.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/gatherv.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/reduce.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/scatter.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/types.cc"
  )

list(APPEND GLOO_HDRS
  "${CMAKE_CURRENT_SOURCE_DIR}/algorithm.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/allgather.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/allgather_ring.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/allgatherv.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/allreduce.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/allreduce_bcube.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/allreduce_halving_doubling.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/allreduce_local.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/allreduce_ring.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/allreduce_ring_chunked.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/alltoall.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/alltoallv.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/barrier.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/barrier_all_to_all.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/barrier_all_to_one.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/broadcast.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/broadcast_one_to_all.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/context.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/gather.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/math.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/pairwise_exchange.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/reduce.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/reduce_scatter.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/scatter.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/types.h"
  )

if(USE_CUDA)
  file(GLOB GLOO_CUDA_SRCS
    "${CMAKE_CURRENT_SOURCE_DIR}/cuda*.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/cuda*.cu"
    )

  file(GLOB GLOO_CUDA_HDRS
    "${CMAKE_CURRENT_SOURCE_DIR}/cuda*.h"
    )
endif()

if(USE_ROCM)
  file(GLOB GLOO_HIP_SRCS
    "${HIPIFY_OUTPUT_DIR}/hip*.cc"
    "${HIPIFY_OUTPUT_DIR}/hip*.hip"
    "${HIPIFY_OUTPUT_DIR}/nccl/nccl.hip"
    )

  file(GLOB GLOO_HIP_HDRS
    "${HIPIFY_OUTPUT_DIR}/hip*.h"
    "${HIPIFY_OUTPUT_DIR}/nccl/nccl.h"
    )
endif()

# Compile TCP transport only on Linux (it uses epoll(2))
if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  set(GLOO_HAVE_TRANSPORT_TCP 1)
else()
  set(GLOO_HAVE_TRANSPORT_TCP 0)
endif()

# Compile ibverbs transport if libibverbs is available
if(USE_IBVERBS)
  set(GLOO_HAVE_TRANSPORT_IBVERBS 1)
else()
  set(GLOO_HAVE_TRANSPORT_IBVERBS 0)
endif()

# Compile uv transport if libuv is available
if(USE_LIBUV)
  set(GLOO_HAVE_TRANSPORT_UV 1)
else()
  set(GLOO_HAVE_TRANSPORT_UV 0)
endif()

add_subdirectory(common)
add_subdirectory(mpi)
if(USE_CUDA AND USE_NCCL)
  add_subdirectory(nccl)
endif()
if(USE_ROCM AND USE_RCCL)
  add_subdirectory(nccl)
endif()
add_subdirectory(rendezvous)
add_subdirectory(transport)

# Depend on pthreads for transport device threads
if(NOT MSVC)
  list(APPEND gloo_DEPENDENCY_LIBS pthread)
endif()

# Enable the following to get a list of source files
if(FALSE)
  message(STATUS "Sources: ")
  foreach(tmp ${GLOO_SRCS})
    message(STATUS "  " ${tmp})
  endforeach()
endif()

# Write configuration header.
# Set variables so macros have GLOO_ prefix.
set(GLOO_USE_CUDA ${USE_CUDA})
set(GLOO_USE_NCCL ${USE_NCCL})
set(GLOO_USE_ROCM ${USE_ROCM})
set(GLOO_USE_RCCL ${USE_RCCL})
set(GLOO_USE_REDIS ${USE_REDIS})
set(GLOO_USE_IBVERBS ${USE_IBVERBS})
set(GLOO_USE_MPI ${USE_MPI})
set(GLOO_USE_AVX ${USE_AVX})
set(GLOO_USE_LIBUV ${USE_LIBUV})
configure_file(config.h.in config.h)

add_library(gloo ${GLOO_STATIC_OR_SHARED} ${GLOO_SRCS})
if(USE_CUDA)
  cuda_add_library(gloo_cuda ${GLOO_CUDA_SRCS} ${GLOO_STATIC_OR_SHARED})
  target_link_libraries(gloo_cuda gloo ${gloo_cuda_DEPENDENCY_LIBS})
endif()
if(USE_ROCM)
  gloo_hip_add_library(gloo_hip ${GLOO_HIP_SRCS})
  target_link_libraries(gloo_hip gloo)
endif()
if(USE_LIBUV)
  target_link_libraries(gloo PRIVATE uv_a)
endif()

target_link_libraries(gloo PRIVATE ${gloo_DEPENDENCY_LIBS})

# Add Interface include directories that are relocatable.
target_include_directories(gloo INTERFACE $<INSTALL_INTERFACE:include>)
if(USE_CUDA)
  target_include_directories(gloo_cuda INTERFACE $<INSTALL_INTERFACE:include>)
endif()
if(USE_ROCM)
  target_include_directories(gloo_hip INTERFACE $<INSTALL_INTERFACE:include>)
endif()

# Install if necessary.
# If the Gloo build is included from another project's build, it may
# want to statically link with Gloo and not install any artifacts.
if(GLOO_INSTALL)
  install(TARGETS gloo EXPORT GlooTargets
      DESTINATION ${CMAKE_INSTALL_PREFIX}/lib)
  if(USE_CUDA)
    install(TARGETS gloo_cuda EXPORT GlooTargets
        DESTINATION ${CMAKE_INSTALL_PREFIX}/lib)
  endif()
  if(USE_ROCM)
    install(TARGETS gloo_hip EXPORT GlooTargets
        DESTINATION ${CMAKE_INSTALL_PREFIX}/lib)
  endif()
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/config.h
    DESTINATION ${CMAKE_INSTALL_PREFIX}/include/gloo)
  foreach(HEADER ${GLOO_HDRS})
    string(REGEX MATCH "(.*)[/\\]" DIR ${HEADER})
    string(REGEX REPLACE "${CMAKE_CURRENT_SOURCE_DIR}" "gloo" DIR ${DIR})
    install(FILES ${HEADER} DESTINATION ${CMAKE_INSTALL_PREFIX}/include/${DIR})
  endforeach()
  if(USE_CUDA)
    foreach(HEADER ${GLOO_CUDA_HDRS})
      string(REGEX MATCH "(.*)[/\\]" DIR ${HEADER})
      string(REGEX REPLACE "${CMAKE_CURRENT_SOURCE_DIR}" "gloo" DIR ${DIR})
      install(FILES ${HEADER} DESTINATION ${CMAKE_INSTALL_PREFIX}/include/${DIR})
    endforeach()
  endif()
  if(USE_ROCM)
    foreach(HEADER ${GLOO_HIP_HDRS})
      string(REGEX MATCH "(.*)[/\\]" DIR ${HEADER})
      string(REGEX REPLACE "${CMAKE_CURRENT_SOURCE_DIR}" "gloo" DIR ${DIR})
      install(FILES ${HEADER} DESTINATION ${CMAKE_INSTALL_PREFIX}/include/${DIR})
    endforeach()
  endif()
endif()

if(MSVC)
  add_definitions(-DNOMINMAX=1)
endif()

if(MSVC AND USE_LIBUV)
  add_custom_command(TARGET gloo POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E copy_if_different
          "${libuv_DLL_PATH}"
          $<TARGET_FILE_DIR:gloo>)
endif()

if(BUILD_TEST)
  add_subdirectory(test)
endif()

if(BUILD_BENCHMARK)
  add_subdirectory(benchmark)
endif()

if(BUILD_EXAMPLES)
  add_subdirectory(examples)
endif()

=== benchmark/CMakeLists.txt ===
set(GLOO_BENCHMARK_SRCS
  "${CMAKE_CURRENT_SOURCE_DIR}/main.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/options.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/runner.cc"
  )

add_executable(benchmark ${GLOO_BENCHMARK_SRCS})
target_link_libraries(benchmark gloo)

if(GLOO_INSTALL)
  install(TARGETS benchmark DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
endif()

if(USE_CUDA)
  set(GLOO_BENCHMARK_CUDA_SRCS
    "${CMAKE_CURRENT_SOURCE_DIR}/cuda_main.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/options.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/runner.cc"
    )

  cuda_add_executable(benchmark_cuda ${GLOO_BENCHMARK_CUDA_SRCS})
  target_link_libraries(benchmark_cuda gloo_cuda)

  if(GLOO_INSTALL)
    install(TARGETS benchmark_cuda DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
  endif()
endif()

if(USE_ROCM)
  set(GLOO_BENCHMARK_HIP_SRCS
    "${HIPIFY_OUTPUT_DIR}/benchmark/hip_main.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/options.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/runner.cc"
    )

  gloo_hip_add_executable(benchmark_hip ${GLOO_BENCHMARK_HIP_SRCS})
  target_link_libraries(benchmark_hip gloo_hip)

  if(GLOO_INSTALL)
    install(TARGETS benchmark_hip DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
  endif()
endif()

=== common/CMakeLists.txt ===
set(GLOO_COMMON_SRCS
  "${CMAKE_CURRENT_SOURCE_DIR}/logging.cc"
  )

set(GLOO_COMMON_HDRS
  "${CMAKE_CURRENT_SOURCE_DIR}/aligned_allocator.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/common.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/error.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/logging.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/string.h"
  )

if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  list(APPEND GLOO_COMMON_SRCS
    "${CMAKE_CURRENT_SOURCE_DIR}/linux.cc"
    )
  list(APPEND GLOO_COMMON_HDRS
    "${CMAKE_CURRENT_SOURCE_DIR}/linux.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/linux_devices.h"
    )
endif()

if(MSVC)
  list(APPEND GLOO_COMMON_HDRS
    "${CMAKE_CURRENT_SOURCE_DIR}/win.h"
    )
  list(APPEND GLOO_COMMON_SRCS
    "${CMAKE_CURRENT_SOURCE_DIR}/win.cc"
    )
endif()

list(APPEND GLOO_SRCS ${GLOO_COMMON_SRCS})
list(APPEND GLOO_HDRS ${GLOO_COMMON_HDRS})
set(GLOO_SRCS ${GLOO_SRCS} PARENT_SCOPE)
set(GLOO_HDRS ${GLOO_HDRS} PARENT_SCOPE)

=== nccl/CMakeLists.txt ===
set(GLOO_NCCL_SRCS
  "${CMAKE_CURRENT_SOURCE_DIR}/nccl.cu"
  )

set(GLOO_NCCL_HDRS
  "${CMAKE_CURRENT_SOURCE_DIR}/nccl.h"
  )

list(APPEND GLOO_CUDA_SRCS ${GLOO_NCCL_SRCS})
list(APPEND GLOO_CUDA_HDRS ${GLOO_NCCL_HDRS})
set(GLOO_CUDA_SRCS ${GLOO_CUDA_SRCS} PARENT_SCOPE)
set(GLOO_CUDA_HDRS ${GLOO_CUDA_HDRS} PARENT_SCOPE)

=== test/CMakeLists.txt ===
set(GLOO_TEST_SRCS
  "${CMAKE_CURRENT_SOURCE_DIR}/allgather_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/allgatherv_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/allreduce_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/alltoall_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/alltoallv_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/barrier_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/broadcast_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/gather_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/gatherv_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/main.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/memory_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/reduce_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/send_recv_test.cc"
  )
set(GLOO_TEST_LIBRARIES)

if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  list(APPEND GLOO_TEST_SRCS
    "${CMAKE_CURRENT_SOURCE_DIR}/linux_test.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/multiproc_test.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/transport_test.cc"
    )
  list(APPEND GLOO_TEST_LIBRARIES rt)
endif()

add_executable(gloo_test ${GLOO_TEST_SRCS})
target_link_libraries(gloo_test gloo gtest ${GLOO_TEST_LIBRARIES})

if(MSVC AND USE_LIBUV)
  add_custom_command(TARGET gloo_test POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E copy_if_different
          "${libuv_DLL_PATH}"
          $<TARGET_FILE_DIR:gloo_test>)
endif()

if(USE_CUDA)
  if(NOT MSVC)
    set(GLOO_TEST_CUDA_SRCS
    "${CMAKE_CURRENT_SOURCE_DIR}/cuda_allreduce_test.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/cuda_base_test.cu"
    "${CMAKE_CURRENT_SOURCE_DIR}/cuda_broadcast_test.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/main.cc"
    )

    cuda_add_executable(gloo_test_cuda ${GLOO_TEST_CUDA_SRCS})
    target_link_libraries(gloo_test_cuda gloo_cuda gtest)
  endif()
endif()

if(USE_ROCM)
  set(GLOO_TEST_HIP_SRCS
    "${HIPIFY_OUTPUT_DIR}/test/hip_allreduce_test.cc"
    "${HIPIFY_OUTPUT_DIR}/test/hip_base_test.hip"
    "${HIPIFY_OUTPUT_DIR}/test/hip_broadcast_test.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/main.cc"
    )

  gloo_hip_add_executable(gloo_test_hip ${GLOO_TEST_HIP_SRCS})
  target_link_libraries(gloo_test_hip gloo_hip gtest)
endif()

=== transport/tcp/CMakeLists.txt ===
if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    message(WARNING "Gloo doesn't support OSX (uses epoll)")
else()
    list(APPEND GLOO_TRANSPORT_SRCS
      "${CMAKE_CURRENT_SOURCE_DIR}/address.cc"
      "${CMAKE_CURRENT_SOURCE_DIR}/buffer.cc"
      "${CMAKE_CURRENT_SOURCE_DIR}/context.cc"
      "${CMAKE_CURRENT_SOURCE_DIR}/device.cc"
      "${CMAKE_CURRENT_SOURCE_DIR}/loop.cc"
      "${CMAKE_CURRENT_SOURCE_DIR}/pair.cc"
      "${CMAKE_CURRENT_SOURCE_DIR}/unbound_buffer.cc"
      )
    list(APPEND GLOO_TRANSPORT_HDRS
      "${CMAKE_CURRENT_SOURCE_DIR}/address.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/attr.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/buffer.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/context.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/device.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/loop.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/pair.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/unbound_buffer.h"
      )
endif()

set(GLOO_TRANSPORT_SRCS ${GLOO_TRANSPORT_SRCS} PARENT_SCOPE)
set(GLOO_TRANSPORT_HDRS ${GLOO_TRANSPORT_HDRS} PARENT_SCOPE)

=== debian/changelog ===
gloo (0.0~git20200918.3dc0328-4) unstable; urgency=medium

  * Remove symbols control file. (Closes: #972729)
    This is a false positive FTBFS for reproducible=+fixfilepath.

 -- Mo Zhou <lumin@debian.org>  Sat, 09 Jan 2021 15:57:00 +0800

gloo (0.0~git20200918.3dc0328-3) unstable; urgency=medium

  * Add libibverbs-dev and libhiredis-dev to Depends of libgloo-dev.
  * Apply wrap-and-sort.

 -- Mo Zhou <lumin@debian.org>  Thu, 10 Dec 2020 19:19:52 +0800

gloo (0.0~git20200918.3dc0328-2) unstable; urgency=medium

  * Disable OpenMPI and remove it from B-D.

 -- Mo Zhou <lumin@debian.org>  Thu, 10 Dec 2020 18:35:50 +0800

gloo (0.0~git20200918.3dc0328-1) unstable; urgency=medium

  * New upstream version 0.0~git20200918.3dc0328
  * Please pin to this upstream snapshot for PyTorch 1.7.0.
  * Change maintainer into Debian Deep Learning Team <debian-ai@l.d.o>
  * Refresh existing patches and symbols control file.

 -- Mo Zhou <lumin@debian.org>  Wed, 04 Nov 2020 14:08:45 +0800

gloo (0.0~git20200724.fe2ad9c-2) unstable; urgency=medium

  * Refresh symbols control file. (fixes amd64/FTBFS)

 -- Mo Zhou <lumin@debian.org>  Mon, 31 Aug 2020 15:26:10 +0800

gloo (0.0~git20200724.fe2ad9c-1) unstable; urgency=medium

  * New upstream version 0.0~git20200724.fe2ad9c
  * Refresh symbols control file. (Closes: #966931)
  * Bump debhelper compat level to 13.

 -- Mo Zhou <lumin@debian.org>  Mon, 31 Aug 2020 11:26:36 +0800

gloo (0.0~git20200408.d6a961a-2) unstable; urgency=medium

  * Apply wrap-and-sort.
  * Refresh symbols control file.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Wed, 29 Apr 2020 08:46:22 +0800

gloo (0.0~git20200408.d6a961a-1) experimental; urgency=medium

  * Initial release. (Closes: #889950)

 -- Mo Zhou <lumin@debian.org>  Thu, 23 Apr 2020 21:16:26 +0800

=== debian/control ===
Source: gloo
Section: science
Homepage: https://github.com/facebookincubator/gloo
Priority: optional
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/deeplearning-team/gloo.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/gloo
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libgtest-dev,
               libhiredis-dev,
               libibverbs-dev
Rules-Requires-Root: no

Package: libgloo-dev
Section: libdevel
Architecture: any
Depends: libgloo0 (= ${binary:Version}),
         libhiredis-dev,
         libibverbs-dev,
         ${misc:Depends}
Description: Collective communications library (development files)
 Gloo is a collective communications library. It comes with a number of
 collective algorithms useful for machine learning applications. These
 include a barrier, broadcast, and allreduce.
 .
 Transport of data between participating machines is abstracted so that
 IP can be used at all times, or InifiniBand (or RoCE) when available.
 In the latter case, if the InfiniBand transport is used, GPUDirect can
 be used to accelerate cross machine GPU-to-GPU memory transfers.
 .
 Where applicable, algorithms have an implementation that works with system
 memory buffers, and one that works with NVIDIA GPU memory buffers. In the
 latter case, it is not necessary to copy memory between host and device;
 this is taken care of by the algorithm implementations.
 .
 This package ships the development files.

Package: libgloo0
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Collective communications library (shared object)
 Gloo is a collective communications library. It comes with a number of
 collective algorithms useful for machine learning applications. These
 include a barrier, broadcast, and allreduce.
 .
 Transport of data between participating machines is abstracted so that
 IP can be used at all times, or InifiniBand (or RoCE) when available.
 In the latter case, if the InfiniBand transport is used, GPUDirect can
 be used to accelerate cross machine GPU-to-GPU memory transfers.
 .
 Where applicable, algorithms have an implementation that works with system
 memory buffers, and one that works with NVIDIA GPU memory buffers. In the
 latter case, it is not necessary to copy memory between host and device;
 this is taken care of by the algorithm implementations.
 .
 This package ships the shared object for Gloo.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS   = hardening=+all
export DEB_CXXFLAGS_MAINT_APPEND = -lpthread
export DEB_LDFLAGS_MAINT_APPEND  = -Wl,--as-needed
#export DPKG_GENSYMBOLS_CHECK_LEVEL = 0

%:
	dh $@ -Scmake

override_dh_auto_configure:
	mkdir third-party
	cd third-party; ln -s /usr/src/googletest googletest
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DUSE_REDIS=ON \
		-DUSE_IBVERBS=ON \
		-DUSE_MPI=OFF \
		-DUSE_LIBUV=OFF \
		-DUSE_CUDA=OFF \
		-DUSE_NCCL=OFF \
		-DBUILD_TEST=OFF \
		-DBUILD_BENCHMARK=OFF \
		-DBUILD_SHARED_LIBS=ON

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test
	-find obj-* -type f -name 'gloo_test' -executable -exec sh -c '{}' +
endif

override_dh_auto_clean:
	-$(RM) -rf third-party

## gloo 0.0~git20220518.5b14351

=== gloo/CMakeLists.txt ===
# GLOO_SRCS is the list of source files that we need to build libgloo.
set(GLOO_SRCS)

# GLOO_HDRS is the list of header files that we need to install.
set(GLOO_HDRS)

# Compiled sources in root directory
list(APPEND GLOO_SRCS
  "${CMAKE_CURRENT_SOURCE_DIR}/algorithm.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/allgather.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/allgatherv.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/allreduce.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/allreduce_local.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/alltoall.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/alltoallv.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/barrier.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/broadcast.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/context.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/gather.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/gatherv.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/reduce.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/scatter.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/types.cc"
  )

list(APPEND GLOO_HDRS
  "${CMAKE_CURRENT_SOURCE_DIR}/algorithm.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/allgather.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/allgather_ring.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/allgatherv.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/allreduce.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/allreduce_bcube.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/allreduce_halving_doubling.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/allreduce_local.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/allreduce_ring.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/allreduce_ring_chunked.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/alltoall.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/alltoallv.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/barrier.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/barrier_all_to_all.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/barrier_all_to_one.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/broadcast.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/broadcast_one_to_all.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/context.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/gather.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/math.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/pairwise_exchange.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/reduce.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/reduce_scatter.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/scatter.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/types.h"
  )

if(USE_CUDA)
  file(GLOB GLOO_CUDA_SRCS
    "${CMAKE_CURRENT_SOURCE_DIR}/cuda*.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/cuda*.cu"
    )

  file(GLOB GLOO_CUDA_HDRS
    "${CMAKE_CURRENT_SOURCE_DIR}/cuda*.h"
    )
endif()

if(USE_ROCM)
  file(GLOB GLOO_HIP_SRCS
    "${HIPIFY_OUTPUT_DIR}/hip*.cc"
    "${HIPIFY_OUTPUT_DIR}/hip*.hip"
    )

  file(GLOB GLOO_HIP_HDRS
    "${HIPIFY_OUTPUT_DIR}/hip*.h"
    )
endif()

# Compile TCP transport only on Linux (it uses epoll(2))
if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  set(GLOO_HAVE_TRANSPORT_TCP 1)
  if(${USE_TCP_OPENSSL_LINK} OR ${USE_TCP_OPENSSL_LOAD})
    find_package(OpenSSL 1.1 REQUIRED EXACT)
    set(GLOO_HAVE_TRANSPORT_TCP_TLS 1)
  else()
    set(GLOO_HAVE_TRANSPORT_TCP_TLS 0)
  endif()
else()
  set(GLOO_HAVE_TRANSPORT_TCP 0)
  set(GLOO_HAVE_TRANSPORT_TCP_TLS 0)
endif()

# Compile ibverbs transport if libibverbs is available
if(USE_IBVERBS)
  set(GLOO_HAVE_TRANSPORT_IBVERBS 1)
else()
  set(GLOO_HAVE_TRANSPORT_IBVERBS 0)
endif()

# Compile uv transport if libuv is available
if(USE_LIBUV)
  set(GLOO_HAVE_TRANSPORT_UV 1)
else()
  set(GLOO_HAVE_TRANSPORT_UV 0)
endif()

add_subdirectory(common)
add_subdirectory(mpi)
if(USE_CUDA AND USE_NCCL)
  add_subdirectory(nccl)
endif()
if(USE_ROCM AND USE_RCCL)
  add_subdirectory(nccl)
endif()
add_subdirectory(rendezvous)
add_subdirectory(transport)

# Depend on pthreads for transport device threads
if(NOT MSVC)
  list(APPEND gloo_DEPENDENCY_LIBS pthread)
endif()

# Enable the following to get a list of source files
if(FALSE)
  message(STATUS "Sources: ")
  foreach(tmp ${GLOO_SRCS})
    message(STATUS "  " ${tmp})
  endforeach()
endif()

# Write configuration header.
# Set variables so macros have GLOO_ prefix.
set(GLOO_USE_CUDA ${USE_CUDA})
set(GLOO_USE_NCCL ${USE_NCCL})
set(GLOO_USE_ROCM ${USE_ROCM})
set(GLOO_USE_RCCL ${USE_RCCL})
set(GLOO_USE_REDIS ${USE_REDIS})
set(GLOO_USE_IBVERBS ${USE_IBVERBS})
set(GLOO_USE_MPI ${USE_MPI})
set(GLOO_USE_AVX ${USE_AVX})
set(GLOO_USE_LIBUV ${USE_LIBUV})
configure_file(config.h.in config.h)

add_library(gloo ${GLOO_STATIC_OR_SHARED} ${GLOO_SRCS})
if(USE_CUDA)
  cuda_add_library(gloo_cuda ${GLOO_CUDA_SRCS} ${GLOO_STATIC_OR_SHARED})
  target_link_libraries(gloo_cuda gloo ${gloo_cuda_DEPENDENCY_LIBS})
endif()
if(USE_ROCM)
  gloo_hip_add_library(gloo_hip ${GLOO_HIP_SRCS})
  target_link_libraries(gloo_hip gloo)
endif()
if(USE_LIBUV)
  target_link_libraries(gloo PRIVATE uv_a)
endif()
if(USE_TCP_OPENSSL_LINK)
  target_compile_definitions(gloo PRIVATE USE_TCP_OPENSSL_LINK)
  target_link_libraries(gloo PRIVATE OpenSSL::SSL OpenSSL::Crypto)
elseif(USE_TCP_OPENSSL_LOAD)
  target_compile_definitions(gloo PRIVATE USE_TCP_OPENSSL_LOAD)
  # Explicitly include the OPENSSL_INCLUDE_DIR, just in case it's not already in our path
  target_include_directories(gloo PRIVATE ${OPENSSL_INCLUDE_DIR})
  target_link_libraries(gloo PRIVATE dl)
endif()

target_link_libraries(gloo PRIVATE ${gloo_DEPENDENCY_LIBS})

# Add Interface include directories that are relocatable.
target_include_directories(gloo INTERFACE $<INSTALL_INTERFACE:include>)
if(USE_CUDA)
  target_include_directories(gloo_cuda INTERFACE $<INSTALL_INTERFACE:include>)
endif()
if(USE_ROCM)
  target_include_directories(gloo_hip INTERFACE $<INSTALL_INTERFACE:include>)
endif()

# Install if necessary.
# If the Gloo build is included from another project's build, it may
# want to statically link with Gloo and not install any artifacts.
if(GLOO_INSTALL)
  install(TARGETS gloo EXPORT GlooTargets
      DESTINATION ${CMAKE_INSTALL_PREFIX}/lib)
  if(USE_CUDA)
    install(TARGETS gloo_cuda EXPORT GlooTargets
        DESTINATION ${CMAKE_INSTALL_PREFIX}/lib)
  endif()
  if(USE_ROCM)
    install(TARGETS gloo_hip EXPORT GlooTargets
        DESTINATION ${CMAKE_INSTALL_PREFIX}/lib)
  endif()
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/config.h
    DESTINATION ${CMAKE_INSTALL_PREFIX}/include/gloo)
  foreach(HEADER ${GLOO_HDRS})
    string(REGEX MATCH "(.*)[/\\]" DIR ${HEADER})
    string(REGEX REPLACE "${CMAKE_CURRENT_SOURCE_DIR}" "gloo" DIR ${DIR})
    install(FILES ${HEADER} DESTINATION ${CMAKE_INSTALL_PREFIX}/include/${DIR})
  endforeach()
  if(USE_CUDA)
    foreach(HEADER ${GLOO_CUDA_HDRS})
      string(REGEX MATCH "(.*)[/\\]" DIR ${HEADER})
      string(REGEX REPLACE "${CMAKE_CURRENT_SOURCE_DIR}" "gloo" DIR ${DIR})
      install(FILES ${HEADER} DESTINATION ${CMAKE_INSTALL_PREFIX}/include/${DIR})
    endforeach()
  endif()
  if(USE_ROCM)
    foreach(HEADER ${GLOO_HIP_HDRS})
      string(REGEX MATCH "(.*)[/\\]" DIR ${HEADER})
      string(REGEX REPLACE "${CMAKE_CURRENT_SOURCE_DIR}" "gloo" DIR ${DIR})
      install(FILES ${HEADER} DESTINATION ${CMAKE_INSTALL_PREFIX}/include/${DIR})
    endforeach()
  endif()
endif()

if(MSVC)
  add_definitions(-DNOMINMAX=1)
endif()

if(MSVC AND USE_LIBUV)
  add_custom_command(TARGET gloo POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E copy_if_different
          "${libuv_DLL_PATH}"
          $<TARGET_FILE_DIR:gloo>)
endif()

if(BUILD_TEST)
  add_subdirectory(test)
endif()

if(BUILD_BENCHMARK)
  add_subdirectory(benchmark)
endif()

if(BUILD_EXAMPLES)
  add_subdirectory(examples)
endif()

=== gloo/examples/CMakeLists.txt ===
if(MSVC)
    add_executable(example_reduce example_reduce.cc)
    target_link_libraries(example_reduce gloo)
    add_executable(example_allreduce example_allreduce.cc)
    target_link_libraries(example_allreduce gloo)

    if(USE_LIBUV)
        add_custom_command(TARGET example_reduce POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy_if_different
                "${libuv_DLL_PATH}"
                $<TARGET_FILE_DIR:example_reduce>)
    endif()
else()
    add_executable(example1 example1.cc)
    target_link_libraries(example1 gloo)
    add_executable(looks_like_mpi looks_like_mpi.cc)
    target_link_libraries(looks_like_mpi gloo)
endif()

=== gloo/test/CMakeLists.txt ===
find_package(OpenSSL 1.1 REQUIRED EXACT)

set(GLOO_TEST_SRCS
  "${CMAKE_CURRENT_SOURCE_DIR}/allgather_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/allgatherv_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/allreduce_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/alltoall_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/alltoallv_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/barrier_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/base_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/broadcast_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/gather_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/gatherv_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/main.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/memory_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/openssl_utils.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/reduce_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/send_recv_test.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/tls_tcp_test.cc"
  )
set(GLOO_TEST_LIBRARIES)

if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  list(APPEND GLOO_TEST_SRCS
    "${CMAKE_CURRENT_SOURCE_DIR}/linux_test.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/multiproc_test.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/transport_test.cc"
    )
  list(APPEND GLOO_TEST_LIBRARIES rt)
endif()

add_executable(gloo_test ${GLOO_TEST_SRCS})
target_link_libraries(gloo_test gloo gtest ${GLOO_TEST_LIBRARIES} OpenSSL::SSL OpenSSL::Crypto)

if(MSVC AND USE_LIBUV)
  add_custom_command(TARGET gloo_test POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E copy_if_different
          "${libuv_DLL_PATH}"
          $<TARGET_FILE_DIR:gloo_test>)
endif()

if(USE_CUDA)
  if(NOT MSVC)
    set(GLOO_TEST_CUDA_SRCS
    "${CMAKE_CURRENT_SOURCE_DIR}/base_test.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/cuda_allreduce_test.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/cuda_base_test.cu"
    "${CMAKE_CURRENT_SOURCE_DIR}/cuda_broadcast_test.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/openssl_utils.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/main.cc"
    )

    cuda_add_executable(gloo_test_cuda ${GLOO_TEST_CUDA_SRCS})
    target_link_libraries(gloo_test_cuda gloo_cuda gtest OpenSSL::SSL OpenSSL::Crypto)
  endif()
endif()

if(USE_ROCM)
  set(GLOO_TEST_HIP_SRCS
    "${HIPIFY_OUTPUT_DIR}/test/hip_allreduce_test.cc"
    "${HIPIFY_OUTPUT_DIR}/test/hip_base_test.hip"
    "${HIPIFY_OUTPUT_DIR}/test/hip_broadcast_test.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/base_test.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/openssl_utils.cc"
    "${CMAKE_CURRENT_SOURCE_DIR}/main.cc"
    )

  gloo_hip_add_executable(gloo_test_hip ${GLOO_TEST_HIP_SRCS})
  target_link_libraries(gloo_test_hip gloo_hip gtest OpenSSL::SSL OpenSSL::Crypto)
endif()

=== debian/changelog ===
gloo (0.0~git20220518.5b14351-5) unstable; urgency=medium

  * d/copyright: add the missing license for uvw.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Sun, 11 Jun 2023 17:05:54 -0700

gloo (0.0~git20220518.5b14351-4) experimental; urgency=medium

  * Enable MPI support.
  * Add the CUDA version packaging (use the cudabuild.sh script)
  * patch: upgrade cuda architecture; refresh patches
  * Patch: also add SOVERSION for cuda/hip version.
  * Update lintian overrides.

 -- Mo Zhou <lumin@debian.org>  Sat, 25 Mar 2023 16:54:40 -0400

gloo (0.0~git20220518.5b14351-3) unstable; urgency=medium

  * Patch code to fix FTBFS against linux 6.0 (Closes: #1022319)

 -- Mo Zhou <lumin@debian.org>  Tue, 01 Nov 2022 11:01:56 -0400

gloo (0.0~git20220518.5b14351-2) unstable; urgency=medium

  * Patch code to fix GCC-12 FTBFS. (Closes: #1012937)

 -- Mo Zhou <lumin@debian.org>  Sat, 23 Jul 2022 09:56:42 -0700

gloo (0.0~git20220518.5b14351-1) unstable; urgency=medium

  * New upstream version 0.0~git20220518.5b14351
    This snapshot should be fine for PyTorch/v1.12.X

 -- Mo Zhou <lumin@debian.org>  Thu, 23 Jun 2022 22:50:56 -0700

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,10 @@
 export DEB_CXXFLAGS_MAINT_APPEND = -lpthread
 export DEB_LDFLAGS_MAINT_APPEND  = -Wl,--as-needed
 #export DPKG_GENSYMBOLS_CHECK_LEVEL = 0
+ifneq (,$(shell command -v nvcc))
+export CC = cuda-gcc
+export CXX = cuda-g++
+endif
 
 %:
 	dh $@ -Scmake
@@ -10,17 +14,40 @@
 override_dh_auto_configure:
 	mkdir third-party
 	cd third-party; ln -s /usr/src/googletest googletest
+ifneq (,$(shell command -v nvcc))
+	# CUDA
 	dh_auto_configure -- \
 		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
 		-DUSE_REDIS=ON \
 		-DUSE_IBVERBS=ON \
-		-DUSE_MPI=OFF \
+		-DUSE_MPI=ON \
+		-DUSE_LIBUV=OFF \
+		-DUSE_CUDA=ON \
+		-DUSE_NCCL=ON \
+		-DUSE_ROCM=OFF \
+		-DUSE_RCCL=OFF \
+		-DBUILD_TEST=OFF \
+		-DBUILD_BENCHMARK=OFF \
+		-DBUILD_SHARED_LIBS=ON
+else ifneq (,$(shell command -v hipcc))
+	# ROCm
+	false
+else
+	# CPU
+	dh_auto_configure -- \
+		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
+		-DUSE_REDIS=ON \
+		-DUSE_IBVERBS=ON \
+		-DUSE_MPI=ON \
 		-DUSE_LIBUV=OFF \
 		-DUSE_CUDA=OFF \
 		-DUSE_NCCL=OFF \
+		-DUSE_ROCM=OFF \
+		-DUSE_RCCL=OFF \
 		-DBUILD_TEST=OFF \
 		-DBUILD_BENCHMARK=OFF \
 		-DBUILD_SHARED_LIBS=ON
+endif
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))

## gloo 0.0~git20230117.1090929

=== transport/tcp/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
-if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
-    message(WARNING "Gloo doesn't support OSX (uses epoll)")
+if(NOT ${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
+    message(WARNING "Gloo TCP transport is supported only on Linux(uses epoll API)")
 else()
     list(APPEND GLOO_TRANSPORT_SRCS
       "${CMAKE_CURRENT_SOURCE_DIR}/address.cc"
@@ -22,5 +22,9 @@
       )
 endif()
 
+if(GLOO_HAVE_TRANSPORT_TCP_TLS)
+    add_subdirectory(tls)
+endif()
+
 set(GLOO_TRANSPORT_SRCS ${GLOO_TRANSPORT_SRCS} PARENT_SCOPE)
 set(GLOO_TRANSPORT_HDRS ${GLOO_TRANSPORT_HDRS} PARENT_SCOPE)

=== debian/changelog ===
gloo (0.0~git20230117.1090929-2) unstable; urgency=medium

  * Fix twice in a row FTBFS (Closes: #1044716)

 -- Mo Zhou <lumin@debian.org>  Sat, 19 Aug 2023 23:16:27 -0400

gloo (0.0~git20230117.1090929-1) experimental; urgency=medium

  * New upstream version 0.0~git20230117.1090929
  * Please pin to this release for PyTorch/v2.0.1 release.
  * Remove merged patches; refresh remaining ones.
  * Add new CUDA related flags and deprecate old patch.
  * Upload to experimental.

 -- Mo Zhou <lumin@debian.org>  Sun, 25 Jun 2023 18:22:14 -0700

=== debian/rules ===
--- 
+++ 
@@ -23,6 +23,7 @@
 		-DUSE_MPI=ON \
 		-DUSE_LIBUV=OFF \
 		-DUSE_CUDA=ON \
+        -DGLOO_USE_CUDA_TOOLKIT=ON \
 		-DUSE_NCCL=ON \
 		-DUSE_ROCM=OFF \
 		-DUSE_RCCL=OFF \
@@ -41,6 +42,7 @@
 		-DUSE_MPI=ON \
 		-DUSE_LIBUV=OFF \
 		-DUSE_CUDA=OFF \
+        -DGLOO_USE_CUDA_TOOLKIT=OFF \
 		-DUSE_NCCL=OFF \
 		-DUSE_ROCM=OFF \
 		-DUSE_RCCL=OFF \
@@ -57,3 +59,4 @@
 
 override_dh_auto_clean:
 	-$(RM) -rf third-party
+	dh_auto_clean

## gloo 0.0~git20230519.597accf

=== CMakeLists.txt ===
--- 
+++ 
@@ -66,20 +66,25 @@
   file(GLOB GLOO_HIP_SRCS
     "${HIPIFY_OUTPUT_DIR}/hip*.cc"
     "${HIPIFY_OUTPUT_DIR}/hip*.hip"
-    "${HIPIFY_OUTPUT_DIR}/nccl/nccl.hip"
     )
 
   file(GLOB GLOO_HIP_HDRS
     "${HIPIFY_OUTPUT_DIR}/hip*.h"
-    "${HIPIFY_OUTPUT_DIR}/nccl/nccl.h"
     )
 endif()
 
 # Compile TCP transport only on Linux (it uses epoll(2))
 if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
   set(GLOO_HAVE_TRANSPORT_TCP 1)
+  if(${USE_TCP_OPENSSL_LINK} OR ${USE_TCP_OPENSSL_LOAD})
+    find_package(OpenSSL 1.1 REQUIRED EXACT)
+    set(GLOO_HAVE_TRANSPORT_TCP_TLS 1)
+  else()
+    set(GLOO_HAVE_TRANSPORT_TCP_TLS 0)
+  endif()
 else()
   set(GLOO_HAVE_TRANSPORT_TCP 0)
+  set(GLOO_HAVE_TRANSPORT_TCP_TLS 0)
 endif()
 
 # Compile ibverbs transport if libibverbs is available
@@ -135,7 +140,12 @@
 
 add_library(gloo ${GLOO_STATIC_OR_SHARED} ${GLOO_SRCS})
 if(USE_CUDA)
-  cuda_add_library(gloo_cuda ${GLOO_CUDA_SRCS} ${GLOO_STATIC_OR_SHARED})
+  if(GLOO_USE_CUDA_TOOLKIT)
+    enable_language(CUDA)
+    add_library(gloo_cuda ${GLOO_STATIC_OR_SHARED} ${GLOO_CUDA_SRCS})
+  else()
+    cuda_add_library(gloo_cuda ${GLOO_CUDA_SRCS} ${GLOO_STATIC_OR_SHARED})
+  endif()
   target_link_libraries(gloo_cuda gloo ${gloo_cuda_DEPENDENCY_LIBS})
 endif()
 if(USE_ROCM)
@@ -144,6 +154,15 @@
 endif()
 if(USE_LIBUV)
   target_link_libraries(gloo PRIVATE uv_a)
+endif()
+if(USE_TCP_OPENSSL_LINK)
+  target_compile_definitions(gloo PRIVATE USE_TCP_OPENSSL_LINK)
+  target_link_libraries(gloo PRIVATE OpenSSL::SSL OpenSSL::Crypto)
+elseif(USE_TCP_OPENSSL_LOAD)
+  target_compile_definitions(gloo PRIVATE USE_TCP_OPENSSL_LOAD)
+  # Explicitly include the OPENSSL_INCLUDE_DIR, just in case it's not already in our path
+  target_include_directories(gloo PRIVATE ${OPENSSL_INCLUDE_DIR})
+  target_link_libraries(gloo PRIVATE dl)
 endif()
 
 target_link_libraries(gloo PRIVATE ${gloo_DEPENDENCY_LIBS})

=== debian/changelog ===
gloo (0.0~git20230519.597accf-2build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 06:00:09 +0000

gloo (0.0~git20230519.597accf-2build2) noble; urgency=medium

  * No-change rebuild against libopenmpi3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 18:25:46 +0000

gloo (0.0~git20230519.597accf-2build1) noble; urgency=medium

  * Rebuild against latest hiredis

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 18 Feb 2024 13:15:38 -0500

gloo (0.0~git20230519.597accf-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Sun, 31 Dec 2023 20:05:10 -0500

gloo (0.0~git20230519.597accf-1) experimental; urgency=medium

  * New upstream version 0.0~git20230519.597accf
    Please pin to this snapshot for PyTorch/v2.1.X releases.
  * Initial attempt to enable to ROCm variant. (still missing build-deps).

 -- Mo Zhou <lumin@debian.org>  Fri, 29 Dec 2023 20:21:36 -0500

=== debian/control ===
--- 
+++ 
@@ -5,13 +5,15 @@
 Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/deeplearning-team/gloo.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/gloo
-Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
 Uploaders: Mo Zhou <lumin@debian.org>
 Build-Depends: cmake,
                debhelper-compat (= 13),
                libgtest-dev,
                libhiredis-dev,
-               libibverbs-dev
+               libibverbs-dev,
+			   mpi-default-dev,
 Rules-Requires-Root: no
 
 Package: libgloo-dev
@@ -21,6 +23,8 @@
          libhiredis-dev,
          libibverbs-dev,
          ${misc:Depends}
+Conflicts: libgloo-cuda-dev
+Replaces: libgloo-cuda-dev
 Description: Collective communications library (development files)
  Gloo is a collective communications library. It comes with a number of
  collective algorithms useful for machine learning applications. These
@@ -42,6 +46,8 @@
 Architecture: any
 Section: libs
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Conflicts: libgloo-cuda-0
+Replaces: libgloo-cuda-0
 Description: Collective communications library (shared object)
  Gloo is a collective communications library. It comes with a number of
  collective algorithms useful for machine learning applications. These

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none" \
https://github.com/facebookincubator/gloo \
HEAD debian uupdate

## gloo 0.0~git20231202.5354032

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)

project(gloo CXX C)

set(GLOO_VERSION_MAJOR 0)
set(GLOO_VERSION_MINOR 5)
set(GLOO_VERSION_PATCH 0)
set(GLOO_VERSION
    "${GLOO_VERSION_MAJOR}.${GLOO_VERSION_MINOR}.${GLOO_VERSION_PATCH}")

# Gloo assumes 64-bit and doesn't run builds/tests for anything else.
if(NOT CMAKE_SIZEOF_VOID_P EQUAL 8)
  message(FATAL_ERROR "Gloo can only be built on 64-bit systems.")
endif()

# Local CMake modules
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/Modules)

# Build target options
option(BUILD_TEST "Build test binary (requires gtest)" OFF)
option(BUILD_BENCHMARK "Build benchmark binary (requires hiredis)" OFF)

# Option defaults (so they can be overwritten before declaring the option)
set(USE_REDIS_DEFAULT OFF)
set(USE_IBVERBS_DEFAULT OFF)
set(USE_NCCL_DEFAULT OFF)
set(USE_RCCL_DEFAULT OFF)
set(USE_LIBUV_DEFAULT OFF)
set(USE_TCP_OPENSSL_LINK_DEFAULT OFF)
set(USE_TCP_OPENSSL_LOAD_DEFAULT OFF)

# Options
option(USE_REDIS "Support using Redis for rendezvous" ${USE_REDIS_DEFAULT})
option(USE_IBVERBS "Support ibverbs transport" ${USE_IBVERBS_DEFAULT})
option(USE_NCCL "Support using NCCL for local collectives" ${USE_NCCL_DEFAULT})
option(USE_RCCL "Support using RCCL for local collectives" ${USE_RCCL_DEFAULT})
option(USE_LIBUV "Build libuv transport" ${USE_LIBUV_DEFAULT})
option(USE_TCP_OPENSSL_LINK "Build TCP-TLS transport with dynamically linked OpenSSL (Linux only)" ${USE_TCP_OPENSSL_LINK_DEFAULT})
option(USE_TCP_OPENSSL_LOAD "Build TCP-TLS transport with OpenSSL dynamically loaded during runtime (Linux only)" ${USE_TCP_OPENSSL_LOAD_DEFAULT})
if(${USE_TCP_OPENSSL_LINK} AND ${USE_TCP_OPENSSL_LOAD})
  message(FATAL_ERROR "USE_TCP_OPENSSL_LINK and USE_TCP_OPENSSL_LOAD are mutually exclusive")
endif()
option(USE_CUDA "Build with CUDA support" OFF)
option(GLOO_USE_CUDA_TOOLKIT "Build CUDA with FindCUDATookit.cmake and enable_language(CUDA)" OFF)

if(MSVC)
  message(STATUS "MSVC detected")
  set(USE_REDIS OFF)
  message(STATUS "Set USE_REDIS OFF")
  set(USE_IBVERBS OFF)
  message(STATUS "Set USE_IBVERBS OFF")
  set(USE_NCCL OFF)
  message(STATUS "Set USE_NCCL OFF")
  set(USE_RCCL OFF)
  message(STATUS "Set USE_RCCL OFF")
  set(USE_LIBUV ON)
  message(STATUS "Set USE_LIBUV ON")
  message(STATUS "Only USE_LIBUV is supported on Windows")

  if(BUILD_BENCHMARK)
    message(FATAL_ERROR "BUILD_BENCHMARK is not supported on Windows yet")
  endif()
endif()

# Set default build type
if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Build type not set -- defaulting to Release")
  set(CMAKE_BUILD_TYPE "Release")
endif()

# Use CMAKE_<LANG>_COMPILER_LAUNCHER if available.
find_program(SCCACHE_EXECUTABLE sccache)
mark_as_advanced(SCCACHE_EXECUTABLE)
if(SCCACHE_EXECUTABLE)
  if(MSVC)
    set(SCCACHE_COMPILE_MATCH_STRING ".*/sccache-cl.exe$")
  else()
    set(SCCACHE_COMPILE_MATCH_STRING ".*/s?ccache$")
  endif()

  foreach(LANG CXX C)
    if(NOT DEFINED CMAKE_${LANG}_COMPILER_LAUNCHER AND NOT CMAKE_${LANG}_COMPILER MATCHES ${SCCACHE_COMPILE_MATCH_STRING})
      message(STATUS "Enabling sccache for ${LANG}")
      set(CMAKE_${LANG}_COMPILER_LAUNCHER ${SCCACHE_EXECUTABLE} CACHE STRING "")
    endif()
  endforeach()
endif()

# Define sanitizer option, if specified.
if(SANITIZE)
  add_definitions("-fsanitize=${SANITIZE}")
  add_definitions("-fno-omit-frame-pointer")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=${SANITIZE}")
endif()

# Add install targets by default (override from parent project)
set(GLOO_INSTALL ON CACHE BOOL "")
mark_as_advanced(GLOO_INSTALL)

# Build shared or static libraries (override from parent project)
if(BUILD_SHARED_LIBS)
  set(GLOO_STATIC_OR_SHARED SHARED CACHE STRING "")
  message(STATUS "Gloo build as SHARED library")
else()
  set(GLOO_STATIC_OR_SHARED STATIC CACHE STRING "")
  message(STATUS "Gloo build as STATIC library")
endif()
mark_as_advanced(GLOO_STATIC_OR_SHARED)

# Process dependencies
include(cmake/Dependencies.cmake)

# Use project root as default include directory
include_directories(${PROJECT_SOURCE_DIR})
include_directories(${PROJECT_BINARY_DIR})

# Compiler flags

if(NOT MSVC)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fPIC")
endif()

# Recurse into main project directory
add_subdirectory(gloo)

# Finally, create the cmake configuration files.
configure_file(
  ${PROJECT_SOURCE_DIR}/cmake/GlooConfigVersion.cmake.in
  ${PROJECT_BINARY_DIR}/cmake/GlooConfigVersion.cmake
  @ONLY)
configure_file(
  ${PROJECT_SOURCE_DIR}/cmake/GlooConfig.cmake.in
  ${PROJECT_BINARY_DIR}/cmake/GlooConfig.cmake
  @ONLY)

if(GLOO_INSTALL)
  if(NOT MSVC)
    install(FILES
      ${PROJECT_BINARY_DIR}/cmake/GlooConfig.cmake
      ${PROJECT_BINARY_DIR}/cmake/GlooConfigVersion.cmake
      DESTINATION share/cmake/Gloo
      COMPONENT dev)
    install(EXPORT GlooTargets DESTINATION share/cmake/Gloo
      FILE GlooTargets.cmake
      COMPONENT dev)
  else()
    install(FILES ${libuv_DLL_PATH} DESTINATION lib)
  endif()
endif()

=== common/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,6 @@
 set(GLOO_COMMON_SRCS
   "${CMAKE_CURRENT_SOURCE_DIR}/logging.cc"
+  "${CMAKE_CURRENT_SOURCE_DIR}/utils.cc"
   )
 
 set(GLOO_COMMON_HDRS
@@ -7,7 +8,9 @@
   "${CMAKE_CURRENT_SOURCE_DIR}/common.h"
   "${CMAKE_CURRENT_SOURCE_DIR}/error.h"
   "${CMAKE_CURRENT_SOURCE_DIR}/logging.h"
+  "${CMAKE_CURRENT_SOURCE_DIR}/store.h"
   "${CMAKE_CURRENT_SOURCE_DIR}/string.h"
+  "${CMAKE_CURRENT_SOURCE_DIR}/utils.h"
   )
 
 if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")

=== nccl/CMakeLists.txt ===
if(USE_CUDA)
    set(GLOO_NCCL_SRCS
      "${CMAKE_CURRENT_SOURCE_DIR}/nccl.cu"
      )

    set(GLOO_NCCL_HDRS
      "${CMAKE_CURRENT_SOURCE_DIR}/nccl.h"
      )

    list(APPEND GLOO_CUDA_SRCS ${GLOO_NCCL_SRCS})
    list(APPEND GLOO_CUDA_HDRS ${GLOO_NCCL_HDRS})
    set(GLOO_CUDA_SRCS ${GLOO_CUDA_SRCS} PARENT_SCOPE)
    set(GLOO_CUDA_HDRS ${GLOO_CUDA_HDRS} PARENT_SCOPE)
endif()

if(USE_ROCM)
    set(GLOO_NCCL_SRCS
      "${HIPIFY_OUTPUT_DIR}/nccl/nccl.hip"
      )

    set(GLOO_NCCL_HDRS
      "${HIPIFY_OUTPUT_DIR}/nccl/nccl.h"
      )

    list(APPEND GLOO_HIP_SRCS ${GLOO_NCCL_SRCS})
    list(APPEND GLOO_HIP_HDRS ${GLOO_NCCL_HDRS})
    set(GLOO_HIP_SRCS ${GLOO_HIP_SRCS} PARENT_SCOPE)
    set(GLOO_HIP_HDRS ${GLOO_HIP_HDRS} PARENT_SCOPE)
endif()

=== transport/ibverbs/CMakeLists.txt ===
list(APPEND GLOO_TRANSPORT_SRCS
  "${CMAKE_CURRENT_SOURCE_DIR}/address.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/buffer.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/context.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/device.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/memory_region.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/pair.cc"
  )

list(APPEND GLOO_TRANSPORT_HDRS
  "${CMAKE_CURRENT_SOURCE_DIR}/address.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/buffer.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/context.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/device.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/memory_region.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/pair.h"
  )

set(GLOO_TRANSPORT_SRCS ${GLOO_TRANSPORT_SRCS} PARENT_SCOPE)
set(GLOO_TRANSPORT_HDRS ${GLOO_TRANSPORT_HDRS} PARENT_SCOPE)

=== debian/changelog ===
gloo (0.0~git20231202.5354032-5) unstable; urgency=medium

  [ Kentaro Hayashi ]
  * Use d/watch 5

  [ Mo Zhou ]
  * Enable libuv for all variants.
  * Compile position independent code.
  * Patch CMake to link against libuv1 dynamically.

 -- Mo Zhou <lumin@debian.org>  Sat, 16 Aug 2025 15:42:05 -0400

gloo (0.0~git20231202.5354032-4) unstable; urgency=medium

  * [CUDA] manually rebuild for libopenmpi40.

 -- Mo Zhou <lumin@debian.org>  Thu, 05 Dec 2024 12:05:49 -0500

gloo (0.0~git20231202.5354032-3) unstable; urgency=medium

  * Manually trigger the rebuild against openmpi5.
    This fixes the libmpi_cxx.so.40 not found issue.

 -- Mo Zhou <lumin@debian.org>  Thu, 05 Dec 2024 12:05:05 -0500

gloo (0.0~git20231202.5354032-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Fri, 27 Sep 2024 02:14:25 -0400

gloo (0.0~git20231202.5354032-1) experimental; urgency=medium

  * New upstream version 0.0~git20231202.5354032
    + Please pin to this snapshot for PyTorch/v2.3.X
  * Build-Depends on architecture-is-64-bit. (Closes: #1061468)
    Thanks Paul Wise for the suggestion!
  * Upload to experimental.

 -- Mo Zhou <lumin@debian.org>  Sun, 14 Jul 2024 00:44:49 -0400

gloo (0.0~git20230519.597accf-3) unstable; urgency=medium

  * Rebuild for libhiredis transition. (Closes: #1063743)

 -- Mo Zhou <lumin@debian.org>  Wed, 24 Apr 2024 22:18:04 -0400

=== debian/control ===
--- 
+++ 
@@ -5,15 +5,17 @@
 Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/deeplearning-team/gloo.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/gloo
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
+Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
 Uploaders: Mo Zhou <lumin@debian.org>
-Build-Depends: cmake,
+Build-Depends: architecture-is-64-bit,
+               cmake,
                debhelper-compat (= 13),
                libgtest-dev,
                libhiredis-dev,
                libibverbs-dev,
-			   mpi-default-dev,
+               libuv1-dev,
+               pkg-config,
+               mpi-default-dev
 Rules-Requires-Root: no
 
 Package: libgloo-dev
